class CreatePolygalleriesIfNecessary < ActiveRecord::Migration
  def up
    unless ActiveRecord::Base.connection.table_exists? 'polygallery_galleries'
      create_table :polygallery_galleries do |t|
        t.string :title, :default => 'gallery'
        t.integer :default_photo_id
        t.integer :galleryable_id
        t.string :galleryable_type
        t.string :class_name

        t.timestamps
      end
    end
    unless ActiveRecord::Base.connection.table_exists? 'polygallery_photos'
      create_table :polygallery_photos do |t|
        t.integer :gallery_id
        t.attachment :photo
        t.string :title
        t.text :caption
        t.string :class_name

        t.timestamps
      end
    end
  end
  def down
    drop_table :polygallery_galleries
    drop_table :polygallery_photos
  end
end
