require 'polygallery'
require 'polygallery/glue'

module Polygallery
  require 'rails'
  class Railtie < Rails::Railtie
    initializer "polygallery.insert_into_active_record" do |app|
      ActiveSupport.on_load :active_record do
        Polygallery::Railtie.insert
      end
      if app.config.respond_to?(:polygallery_defaults)
        Polygallery::Gallery.default_options.merge!(app.config.polygallery_defaults)
      end
    end

    def self.insert
      if defined?(ActiveRecord)
        ActiveRecord::Base.send(:include, Polygallery::Glue)
      end
    end
  end
end
