require 'active_model/validations/presence'

module Polygallery
  module Validators
    class PolygalleryPresenceValidator < ActiveModel::EachValidator

      def validate_each(record, attribute, value)
        if record.send(attribute).present?
          unless record.send(attribute).photos.any?
            record.errors.add(attribute, :blank, options)
          end
        else
          record.errors.add(attribute, :blank, options)
        end
      end

      def self.helper_method_name
        :validates_polygallery_presence
      end

    end

    module HelperMethods
      def validates_polygallery_presence(*attr_names)
        options = _merge_attributes(attr_names)
        validates_with PolygalleryPresenceValidator, options.dup
      end
    end
  end
end